﻿
# -*- coding:Utf-8 -*-


import es
import popuplib2
import gamethread
import playerlib
import vecmath
import math
import random

info = es.AddonInfo()
info.name     = "WH Popup"
info.version  = "1.00"
info.url      = "http://addons.eventscripts.com/addons/view/whpopup"
info.basename = "whpopup"
info.author   = "sega74rus"
es.ServerVar('whpopup', info.version, info.name).makepublic()




import psyco
psyco.full()


timespeed = 0.1



class Admins(object):
       
    def __init__(self):
        self.path = es.getAddonPath("whpopup") +'/admins.txt'      
    def update(self):
        t = open(self.path).read().lstrip('\xef\xbb\xbf').split('\n')
        self.spisSteam = [s.split('//')[0].strip() for s in t if s.split()\
            and  s.strip().startswith('STEAM_') and not s.strip().startswith('//')]
            
        self.spisIP = [s.split('//')[0].strip() for s in t if s.strip()  and\
                not s.strip().startswith('//') and  s.count('.')==3]

    def isadmin(self,uid):   
        pl = playerlib.getPlayer(uid)
        if pl.steamid in self.spisSteam:
            return 1
        if pl.address.split(':')[0] in self.spisIP:
            return 1 
        return 0 
        
admin = Admins()    
    
    
class Players(object):  
    def __init__(self,userid):
        self.userid = userid
        self.tab = 0
        self.use = 0
        self.whON = 0
        self.popup = popuplib2.Popup()
        self.popup.menuselect = self.callback
    def callback(self,params):
        choice = params['choice']
        #es.tell(userid, 'You pressed %s' % (choice,) ) 
        if choice ==10:
           self.whON = 0
        else:
            pl = playerlib.getPlayer(self.userid)
            if choice == 1:
                w = pl.getPrimary()
            elif choice == 2:
                w = pl.getSecondary() 
            elif choice == 3:
                w = 'weapon_knife' 
            elif choice == 4:
                
                gre = ['weapon_hegrenade', 'weapon_flashbang', 'weapon_smokegrenade']
                actweap = es.createplayerlist(self.userid)[self.userid]['weapon']
                pl = playerlib.getPlayer(self.userid)
                allweap = pl["weaponlist"]
                gre = [g for g in gre if g in allweap]
                if not gre:
                    return

                if actweap in gre:
                    ind = gre.index(actweap)
                    ind = ind+1 if ind < len(gre)-1 else 0
                    w = gre[ind]
                else:
                    w = gre[0]
                
            elif choice == 5:
                w = 'weapon_c4'
            else:
                return
            es.sexec(self.userid, 'use '+w)
            
    def whskaner(self):
        
        team = es.getplayerteam(self.userid)
        if team>1:
            self.whON = 1
            self.teamA = 5-team
            
        else:
            es.tell(self.userid,'bad idea')
            
    def skan(self):
        ckaner(self.userid,self.teamA,self.popup)
            
            
    def switch(self):
        if self.tab and self.use :
            if self.whON:
                self.whON = 0
                self.popup.unsend(self.userid)
            else:
                team = es.getplayerteam(self.userid)
                if team>1:
                    self.whON = 1
                    self.teamA = 5-team
                else:
                    es.tell(self.userid,'bad idea')
    

class Singleton(type):
     def __init__(cls, name, bases, dict):
         super(Singleton, cls).__init__(name, bases, dict)
         cls.instance = None
     def __call__(cls,*args,**kw):
         if cls.instance is None:
             cls.instance = super(Singleton, cls).__call__(*args, **kw)
         return cls.instance
    
    
class DictPlayer(dict):
    __metaclass__ = Singleton  
    keypressmodule = None
    def sm2esPress(self,userid,command,status):
        if not self.keypressmodule:
            self.keypressmodule = 'sm2es'
        
        if self.keypressmodule  != 'sm2es':
            return


        
        if command == 'IN_SCORE': 
            self[userid].tab = status
            self[userid].switch()
        elif  command == 'IN_USE':    
            self[userid].use = status
            self[userid].switch()
            
            
    def client_keypress(self,userid,command,status):
    
        if not self.keypressmodule:
            self.keypressmodule = 'clkpr'
        
        if self.keypressmodule  != 'clkpr':
            return
            
        if command == 'score': 
            self[userid].tab = status
            self[userid].switch()
        elif  command == 'use':    
            self[userid].use = status
            self[userid].switch()        
            
        
 
    
allplayers =  DictPlayer()


def foo():
    gamethread.cancelDelayed('go')
    for id in allplayers:
        pl = allplayers[id]
        if  pl.whON: 
            try:
                pl.skan()
            except Exception, e:
                pl.whON = 0
                print e
            
    gamethread.delayedname(timespeed, 'go',  foo)          

    
def es_map_start(*e):
    admin.update()
    gamethread.delayedname(timespeed, 'go',  foo)  
    
def load():
    es_map_start()
    
def unload():
    gamethread.cancelDelayed('go')   
    


        


def sm2es_keyPress(event_var):
    userid = int(event_var["userid"])
    command = event_var["command"]
    status = int(event_var["status"])
    if userid in allplayers:
        allplayers.sm2esPress(userid,command,status)
    
    
def client_keypress(event_var):
    userid =  int(event_var["userid"])
    keyname = event_var["keyname"]
    status = int(event_var["status"])
    if userid in allplayers:
        allplayers.client_keypress(userid,keyname,status)


def player_activate(event_var):
    userid =  int(event_var["userid"])
    if userid not in allplayers:
        if admin.isadmin(userid):
            allplayers[userid]= Players(userid)
            es.tell(userid,'\3Press \5TAB + E \3 for open WH Popup ') 
    
    
    
def player_team(event_var):

    userid =  int(event_var["userid"])

    team = int(event_var['team'])
    

    if userid in allplayers and team>1:
        allplayers[userid].teamA = 5-team
    
def player_disconnect(event_var):
    userid =  int(event_var["userid"])
    if userid in allplayers:
        del allplayers[userid]

def rad2gr(rad):
    return '%.1f'%(rad*180/math.pi)
        
def ckaner(uid,teamA,pp):

    del pp[:7]
    lines =[ ['▁' for g in range(34)] for bb in range(5)] 
    
    lines[2][17]='╳' # centr ╭╮╯╰
    
    lines[1][17]='░' #▏ 
    lines[3][17]='░' #▕ 
    x,y,z = es.getplayerlocation(uid)
    if es.getplayerprop(uid, 'CBasePlayer.localdata.m_Local.m_bDucked')%2:
        z += 44
    else:
        z += 64   
    myEyeAngle0 = es.getplayerprop(uid, 'CCSPlayer.m_angEyeAngles[0]') # vn
    myEyeAngle1 = es.getplayerprop(uid, 'CCSPlayer.m_angEyeAngles[1]') # LR
    myEyeAngle0 =  math.pi/180 * myEyeAngle0 
    myEyeAngle1 =  math.pi/180 * myEyeAngle1 
   
    for vuid in  es.getUseridList():
        if teamA != es.getplayerteam(vuid) or\
            es.getplayerprop(vuid, 'CBasePlayer.pl.deadflag') :
            continue

        xa,ya,za = es.getplayerlocation(vuid) 
        if es.getplayerprop(vuid, 'CBasePlayer.localdata.m_Local.m_bDucked')%2:
            za += 44
        else:
            za += 64
        a = xa - x 
        b = ya - y 
        c = za - z
        if a == 0: a = 0.0000000001 
         
        A = math.atan2(b,a)
        dA = myEyeAngle1-A
        if dA> 3.0: 
            dA = dA- 2*math.pi 
        if dA< -3.0: 
            dA = dA+ 2*math.pi 
            
        
        vert = math.sqrt(a**2+b**2)
        Bv = math.atan(-c/abs(vert))
        dB = myEyeAngle0 - Bv

        if abs(dA)<math.pi/4:    
            mx = int((dA)*68/(math.pi))+17
            my = 4 - int((dB)*32/(math.pi))

            
            norm = '▉'
            pup  = '▀'
            pdown= '▅'
            if my > 8:
                lines[-1][mx] =   pdown
            elif my < 0:
                lines[0][mx] =   pup
            
            elif my%2:

                lines[my/2][mx]        = pdown
                lines[my/2+1][mx]      = pup 
            else:
                lines[my/2][mx] =   norm
                
                        
    pref ={3:'C',2:'T'}[teamA] + str(es.getlivingplayercount(teamA))
    
    lines[-1][-len(pref):] =   pref
    
    for lin in lines:  
        pp.append(''.join(lin)) 
        
    pp.send(uid)     

